c====================================================================
c
c		ggdelta
c
c====================================================================


c=========================================================================	

      double precision function gg_me(whichpart,z,lambda,QQQ,wlo)
      implicit none
      character*5 whichpart
      
      double precision QQQ,gg_LO_exact,gg_n0
      double precision gg_n1,gg_n2
      double precision z,gg_NLO_exact,lambda
      integer wlo
      double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO
      double precision WC2NNLO
      common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
      !: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
      integer effective_theory_flag
      common /common_eff_theory_flag/ effective_theory_flag
c -------
      if (effective_theory_flag.eq.0) then 
         select case (wlo)
         case(0)
            gg_me = gg_LO_exact(whichpart,z,QQQ) 
     #+ WC0LO * gg_n0(whichpart,z)
         case(1)
            gg_me = gg_NLO_exact(whichpart,z,lambda,QQQ)
     #+ WC1NLO * gg_n0(whichpart,z) 
     #+ WC0NLO * gg_n1(whichpart,z) 
         case(2)
            gg_me = WC2NNLO * gg_n0(whichpart,z) 
     #+ WC1NNLO * gg_n1(whichpart,z)
     #+ WC0NNLO * gg_n2(whichpart,z)
         end select
      elseif (effective_theory_flag.eq.1) then
         select case (wlo)
         case(0)
            gg_me =   WC0LO * gg_n0(whichpart,z)
         case(1)
            gg_me =  WC1NLO * gg_n0(whichpart,z) 
     #+ WC0NLO * gg_n1(whichpart,z) 
         case(2)
            gg_me = WC2NNLO * gg_n0(whichpart,z) 
     #+ WC1NNLO * gg_n1(whichpart,z)
     #+ WC0NNLO * gg_n2(whichpart,z)
         end select
      endif
      end


      double precision function gg_LO_exact(whichpart,z,QQQ)
      implicit none
      character*5 whichpart
      double precision z,QQQ,ggdelta_LO_exact
      if (whichpart.eq.'delt') then 
         gg_LO_exact=ggdelta_LO_exact(QQQ)
      elseif (whichpart.eq.'plus') then 
         gg_LO_exact=0d0
      elseif (whichpart.eq.'regu') then 
         gg_LO_exact=0d0
      endif
     
     
      end

      double precision function gg_NLO_exact(whichpart,z,lambda,QQQ)
      implicit none
      character*5 whichpart
      double precision z,lambda,QQQ,ggdelta_NLO_exact,gg_n1
      double precision ggreg_exact_NLO
      double complex sborn_mass
      if (whichpart.eq.'delt') then 
          gg_NLO_exact=ggdelta_NLO_exact(QQQ)
      elseif (whichpart.eq.'plus') then 
          gg_NLO_exact=gg_n1(whichpart,z)* abs(sborn_mass(QQQ))**2 ! NLO exact
      elseif (whichpart.eq.'regu') then 
          gg_NLO_exact=ggreg_exact_NLO(z,lambda,QQQ)
      endif


      end

c=========================================================================	
      double precision function ggdelta_LO_exact(QQQ)
      implicit none 
      double precision QQQ
      double complex sborn_mass	
      ggdelta_LO_exact = abs(sborn_mass(QQQ))**2
      end
c=========================================================================	
	double precision function ggdelta_NLO_exact(QQQ)
	implicit none 
	double precision QQQ
	double complex sborn_mass,sum_q_born,sum_q_virtual_star
	double complex svirtual_mass	
	double precision L, Lt, Lr, NF, pi, z2, z3
        common /xsection/ L, Lt, Lr, NF 
        common /consts/ pi, z2, z3
	double precision b0,z4
	!note: beta_0 below HARDCODED with nf=5
	b0=23d0/12d0  
	z4=1.082323234d0
	sum_q_born =  sborn_mass(QQQ)
	sum_q_virtual_star = CONJG(svirtual_mass(QQQ))
c			Lr=log(mur**2/mhiggs**2)   L=log(muf**2/mhiggs**2)
	ggdelta_NLO_exact = abs(sum_q_born)**2  * (2d0*b0*(Lr-L) + pi**2)
     #     +	2d0*dreal(sum_q_born*sum_q_virtual_star)   
c      print*,"ratio ",ggdelta_NLO_exact/ ( abs(sum_q_born)**2  * 
c     #		(2d0*b0*(Lr-L) + pi**2)
c     #     +	abs(sum_q_born)**2  *11d0/2d0)     
c     #		+  abs(sum_q_born)**2  *11d0/2d0 
	!print*,sum_q_born,sum_q_virtual_star
	end

c=========================================================================	

      double precision function gg_n0(whichpart,z)
      implicit none
      character*4 whichpart
      double precision res,z,EggLO

      gg_n0=EggLO(whichpart,z)
      end

c=========================================================================	

      double precision function gg_n1(whichpart,z)
      implicit none
      character*4 whichpart
      double precision res,z,EggLO,EggNLO
      double precision B0
      double precision L, Lt, Lr, NF
      common /xsection/ L, Lt, Lr, NF

      B0 = 11d0/4d0 - 1d0/6d0 * NF

      gg_n1=(-2d0*B0*L+2d0*B0*Lr)*EggLO(whichpart,z)
     $         +EggNLO(whichpart,z)
      end
c=========================================================================	

      double precision function gg_n2(whichpart,z)
      implicit none
      character*4 whichpart
      double precision res,z,EggLO,EggNLO,EggNNLO
      double precision B0,B1
      double precision L, Lt, Lr, NF
      common /xsection/ L, Lt, Lr, NF
      
      B0 = 11d0/4d0 - 1d0/6d0 * NF
      B1 = 51d0/8d0 - 19d0/24d0 * NF


      gg_n2=(3d0*B0**2*Lr**2+3d0*B0**2*L**2+4d0*B1*Lr
     $    +(-6d0*B0**2*Lr-4d0*B1)*L)*EggLO(whichpart,z)
     $    +(3d0*B0*Lr-3d0*B0*L)*EggNLO(whichpart,z)
     $    +EggNNLO(whichpart,z)

      
      end

c=========================================================================	

      double precision function EggLO(whichpart,x)
      implicit none
      character*4 whichpart
      double precision res,x

      if (whichpart.eq.'delt') then 
          EggLO=1d0
      elseif (whichpart.eq.'plus') then 
          EggLO=0d0
      elseif (whichpart.eq.'regu') then 
          EggLO=0d0
	 endif
      !print*,"\nEggLO=",EggLO," : ",whichpart
      end
c=========================================================================	

      double precision function EggNLO(whichpart,x)
      implicit none
      character*4 whichpart
      double precision res,x
      double precision L, Lt, Lr, NF
      common /xsection/ L, Lt, Lr, NF
      double precision LLz,DD0,DD1,DD2,DD3
      double precision pi,z2,z3
      common /consts/ pi, z2, z3      

      LLz = dlog(1d0-x)
      DD0=1d0
      DD1=LLz
      DD2=LLz**2
      DD3=LLz**3

      if (whichpart.eq.'delt') then 
          res=6d0*z2
      elseif (whichpart.eq.'plus') then 
          res= -6d0*L*DD0+12*DD1
      elseif (whichpart.eq.'regu') then 
          res=(6d0*(x**3-x**2+2d0*x-1d0))*L/x
     $         +6d0*(x**2-x+1d0)**2*dlog(x)/((x-1d0)*x)
     $         +(11d0/2d0)*(x-1d0)**3/x
     $         -(12d0*(x**3-x**2+2d0*x-1d0))*dlog(1d0-x)/x
      endif
      EggNLO=res
      end

c=========================================================================	

      double precision function EggNNLO(whichpart,x)
c      implicit none
      implicit double precision (t)
      character*4 whichpart
      double precision res,x
      double precision L, Lt, Lr, NF
      common /xsection/ L, Lt, Lr, NF
      double precision LLz,DD0,DD1,DD2,DD3
      double precision pi,z2,z3
      common /consts/ pi, z2, z3  
      double precision z4
      double precision Li2,Li3,S12

      z4=1.082323234d0
      LLz = dlog(1d0-x)
      DD0=1d0
      DD1=LLz
      DD2=LLz**2
      DD3=LLz**3

      if (whichpart.eq.'delt') then 
      EggNNLO= 0.33D2 / 0.2D1 * L * z2 
     $ - 0.171D3 / 0.2D1 * L * z3 + 0.27D2 /
     # 0.2D1 * L - 0.18D2 * z2 * L ** 2 + 0.1071D4 / 0.8D1 * z4 - 0.54D2
     # * z2 ** 2 + 0.67D2 / 0.2D1 * z2 - 0.165D3 / 0.4D1 * z3 + 0.837D3 
     #/ 0.16D2 + (-L * z2 - 0.11D2 / 0.6D1 * L - 0.5D1 / 0.3D1 * z2 + 0.
     #5D1 / 0.6D1 * z3 - 0.247D3 / 0.36D2) * NF

      elseif (whichpart.eq.'plus') then 
      EggNNLO=(DD0 * L ** 2 / 0.2D1 + 0.5D1 / 0.3D1 * DD0 * L 
     $ - 0.2D1 * DD0
     # * z2 + 0.14D2 / 0.9D1 * DD0 - 0.2D1 * DD1 * L - 0.10D2 / 0.3D1 * 
     #DD1 + dble(2 * DD2)) * NF + 0.351D3 / 0.2D1 * DD0 * z3 + 0.33D2 * 
     #DD0 * z2 - 0.101D3 / 0.3D1 * DD0 + 0.45D2 * DD0 * L * z2 - 0.67D2 
     #/ 0.2D1 * DD0 * L - 0.33D2 / 0.4D1 * DD0 * L ** 2 - 0.90D2 * DD1 *
     # z2 + 0.67D2 * DD1 + 0.33D2 * DD1 * L + 0.36D2 * DD1 * L ** 2 - db
     #le(33 * DD2) - 0.108D3 * dble(DD2) * L + dble(72 * DD3)

      elseif (whichpart.eq.'regu') then 
      t1 = dlog(x)
      t2 = L * t1
      t3 = 0.1D1 - x
      t4 = dlog(t3)
      t5 = x ** 2
      t6 = t5 ** 2
      t7 = t4 * t6
      t10 = t6 * x
      t11 = t4 * t10
      t14 = t5 * x
      t15 = t4 * t14
      t18 = t4 * t5
      t21 = t4 * x
      t24 = x + 0.1D1
      t25 = dlog(t24)
      t42 = z2 * t1
      t47 = t42 * x
      t49 = 0.18321D5 + 0.6048D4 * t7 * t2 - 0.6048D4 * t2 * t11 - 0.604
     #8D4 * t2 * t15 - 0.6048D4 * t2 * t18 + 0.6048D4 * t2 * t21 - 0.864
     #D3 * t2 * t25 * t10 - 0.864D3 * t2 * t25 * t6 - 0.864D3 * t2 * t25
     # * t14 + 0.864D3 * t2 * t25 * t5 + 0.864D3 * t2 * t25 * x - 0.1852
     #3D5 * x + 0.8208D4 * t42 * t6 - 0.4320D4 * t42 * t10 - 0.2592D4 * 
     #t47
      t50 = t1 * t4
      t51 = t50 * t14
      t53 = t50 * t5
      t55 = t50 * x
      t57 = t1 * t25
      t68 = L ** 2
      t69 = t68 * t1
      t71 = 0.864D3 * t69 * t14
      t73 = 0.864D3 * t69 * x
      t74 = t2 * t6
      t76 = t2 * t14
      t78 = t2 * t5
      t80 = t2 * x
      t82 = L * t4
      t83 = t82 * t6
      t85 = t82 * t14
      t87 = -0.1692D4 * t51 + 0.396D3 * t53 + 0.21492D5 * t55 + 0.792D3 
     #* t57 * t10 + 0.1512D4 * t57 * t6 - 0.1656D4 * t57 * t14 - 0.2520D
     #4 * t57 * t5 + 0.864D3 * t57 * x - t71 + t73 - 0.11952D5 * t74 - 0
     #.5328D4 * t76 + 0.7200D4 * t78 - 0.7344D4 * t80 + 0.16704D5 * t83 
     #- 0.2448D4 * t85
      t89 = t82 * t5
      t91 = t82 * x
      t93 = Li2(x)
      t94 = L * t93
      t95 = t94 * t14
      t97 = t94 * x
      t99 = t1 ** 2
      t100 = L * t99
      t101 = t100 * t14
      t103 = t100 * x
      t105 = t1 * t93
      t106 = t105 * t14
      t108 = t105 * t5
      t110 = t105 * x
      t112 = t4 * t93
      t113 = t112 * t14
      t115 = t112 * t5
      t117 = t112 * x
      t119 = t99 * t4
      t120 = t119 * t14
      t122 = t119 * t5
      t124 = t119 * x
      t126 = -0.864D3 * t89 + 0.18288D5 * t91 - 0.6048D4 * t95 + 0.6048D
     #4 * t97 - 0.1296D4 * t101 + 0.1296D4 * t103 - 0.5400D4 * t106 + 0.
     #12744D5 * t108 + 0.6696D4 * t110 - 0.216D3 * t113 - 0.648D3 * t115
     # + 0.648D3 * t117 - 0.3024D4 * t120 - 0.2592D4 * t122 + 0.2592D4 *
     # t124
      t127 = t4 ** 2
      t128 = t127 * t1
      t129 = t128 * t14
      t131 = t128 * t5
      t133 = t128 * x
      t143 = t68 * t4
      t162 = 0.6588D4 * t129 + 0.6372D4 * t131 - 0.6372D4 * t133 + 0.134
     #64D5 * t2 * t10 - 0.15840D5 * t82 * t10 - 0.2592D4 * t69 * t6 + 0.
     #2592D4 * t69 * t5 + 0.1728D4 * t143 * t6 - 0.1728D4 * t143 * t14 +
     # 0.3456D4 * t143 * x + 0.864D3 * t69 * t10 - 0.1728D4 * t143 * t10
     # - 0.6048D4 * t94 * t6 + 0.6048D4 * t94 * t5 - 0.3456D4 * t100 * t
     #6 + 0.3456D4 * t100 * t5
      t177 = Li2(t5)
      t178 = L * t177
      t195 = L * t127
      t198 = -0.14040D5 * t105 * t6 + 0.1080D4 * t112 * t6 + 0.2160D4 * 
     #t119 * t6 - 0.6156D4 * t128 * t6 + 0.2376D4 * t105 * t10 + 0.864D3
     # * t94 * t10 - 0.432D3 * t178 * t10 - 0.432D3 * t178 * t6 - 0.432D
     #3 * t178 * t14 + 0.432D3 * t178 * t5 + 0.432D3 * t178 * x - 0.6048
     #D4 * t2 * t4 + 0.864D3 * t25 * t2 + 0.1296D4 * t100 * t10 + 0.5184
     #D4 * t195 * t10
      t205 = t25 * t93
      t218 = t177 * t25
      t225 = t99 * t25
      t234 = -0.5184D4 * t195 * t6 + 0.5184D4 * t195 * t14 - 0.10368D5 *
     # t195 * x - 0.1728D4 * t205 * t10 - 0.1728D4 * t205 * t6 - 0.5616D
     #4 * t205 * t14 + 0.3024D4 * t205 * t5 + 0.3024D4 * t205 * x + 0.63
     #72D4 * t128 * t10 + 0.1944D4 * t218 * t14 - 0.648D3 * t218 * t5 - 
     #0.648D3 * t218 * x - 0.432D3 * t225 * t10 - 0.432D3 * t225 * t6 - 
     #0.2052D4 * t225 * t14 + 0.972D3 * t225 * t5
      t238 = t25 ** 2
      t239 = t1 * t238
      t246 = t1 * t177
      t259 = L * z2
      t264 = t259 * t14
      t268 = t259 * x
      t272 = 0.972D3 * t225 * x + 0.1944D4 * t239 * t14 - 0.648D3 * t239
     # * t5 - 0.648D3 * t239 * x + 0.216D3 * t246 * t10 - 0.216D3 * t246
     # * t6 - 0.1620D4 * t246 * t14 + 0.540D3 * t246 * t5 + 0.540D3 * t2
     #46 * x - 0.2592D4 * t119 * t10 - 0.2592D4 * t259 * t10 + 0.8640D4 
     #* t259 * t6 + 0.4320D4 * t264 - 0.6480D4 * t259 * t5 - 0.2160D4 * 
     #t268 - 0.648D3 * t112 * t10
      t273 = t50 * t6
      t277 = t25 * z2
      t288 = t4 * z2
      t293 = t288 * t14
      t295 = t288 * t5
      t297 = t288 * x
      t301 = t42 * t14
      t306 = 0.20700D5 * t273 - 0.21780D5 * t50 * t10 + 0.1728D4 * t277 
     #* t10 + 0.1728D4 * t277 * t6 + 0.3672D4 * t277 * t14 - 0.2376D4 * 
     #t277 * t5 - 0.2376D4 * t277 * x + 0.4968D4 * t288 * t10 - 0.5400D4
     # * t288 * t6 + 0.4536D4 * t293 + 0.648D3 * t295 - 0.9288D4 * t297 
     #- 0.7776D4 * t42 * t5 + 0.2592D4 * t301 - 0.1728D4 * t259 - 0.1782
     #0D5 * z2 * t10
      t310 = z2 * t6
      t312 = z2 * t14
      t314 = z2 * t5
      t316 = z2 * x
      t318 = z3 * t5
      t320 = z3 * x
      t326 = z3 * t14
      t331 = t1 * t6
      t333 = t1 * t14
      t335 = t1 * t5
      t337 = 0.14076D5 * t310 + 0.11592D5 * t312 - 0.11520D5 * t314 + 0.
     #6624D4 * t316 + 0.4320D4 * t318 + 0.11232D5 * t320 - 0.7128D4 * z3
     # * t10 + 0.3240D4 * z3 * t6 - 0.2808D4 * t326 - 0.2376D4 * t277 + 
     #0.4968D4 * t288 - 0.864D3 * t42 - 0.14238D5 * t331 - 0.4632D4 * t3
     #33 + 0.3432D4 * t335
      t338 = t1 * x
      t346 = t93 * t6
      t348 = t93 * t14
      t350 = t93 * t5
      t352 = t93 * x
      t365 = -0.18084D5 * t338 + 0.22728D5 * t7 + 0.1632D4 * t15 + 0.481
     #2D4 * t18 + 0.25908D5 * t21 + 0.4356D4 * t93 * t10 - 0.6444D4 * t3
     #46 - 0.7668D4 * t348 + 0.17460D5 * t350 + 0.2916D4 * t352 + 0.396D
     #3 * t177 * t10 + 0.756D3 * t177 * t6 - 0.828D3 * t177 * t14 - 0.12
     #60D4 * t177 * t5 + 0.432D3 * t177 * x - 0.23076D5 * t50
      t370 = t99 * t1
      t371 = t370 * x
      t375 = t99 * t5
      t377 = t99 * t14
      t379 = t99 * t6
      t383 = t99 * x
      t389 = t127 * t6
      t391 = t127 * t14
      t393 = 0.1008D4 * t57 + 0.2376D4 * t105 - 0.648D3 * t112 + 0.504D3
     # * t371 - 0.2592D4 * t119 + 0.6372D4 * t128 + 0.5580D4 * t375 - 0.
     #2304D4 * t377 - 0.8154D4 * t379 + 0.6732D4 * t99 * t10 - 0.4230D4 
     #* t383 + 0.24324D5 * t1 * t10 + 0.15840D5 * t127 * t10 - 0.16704D5
     # * t389 + 0.2448D4 * t391
      t394 = t127 * x
      t399 = Li3(x)
      t400 = t399 * t14
      t402 = t399 * t5
      t404 = t399 * x
      t406 = S12(x)
      t407 = t406 * t14
      t409 = t406 * t5
      t411 = t406 * x
      t413 = t370 * t14
      t415 = t127 * t5
      t423 = -0.18288D5 * t394 - 0.27540D5 * t11 + 0.5544D4 * t2 - 0.158
     #40D5 * t82 + 0.6264D4 * t400 - 0.16200D5 * t402 - 0.7560D4 * t404 
     #- 0.12312D5 * t407 + 0.11448D5 * t409 + 0.12744D5 * t411 - 0.504D3
     # * t413 + 0.864D3 * t415 + 0.864D3 * t69 - 0.1728D4 * t143 + 0.129
     #6D4 * t370 * t5 + 0.16848D5 * t399 * t6
      t430 = S12(t5)
      t441 = S12(-x)
      t452 = Li3(t5)
      t459 = -0.11016D5 * t406 * t6 - 0.1224D4 * t370 * t6 - 0.864D3 * t
     #430 * t10 - 0.864D3 * t430 * t6 - 0.864D3 * t430 * t14 + 0.864D3 *
     # t430 * t5 + 0.864D3 * t430 * x + 0.1728D4 * t441 * t10 + 0.1728D4
     # * t441 * t6 + 0.5616D4 * t441 * t14 - 0.3024D4 * t441 * t5 - 0.30
     #24D4 * t441 * x - 0.432D3 * t452 * t10 + 0.594D3 * t452 * t14 - 0.
     #54D2 * t452 * t5
      t462 = t127 * t4
      t484 = -0.54D2 * t452 * x - 0.3456D4 * t462 * t10 + 0.3456D4 * t46
     #2 * t6 - 0.3456D4 * t462 * t14 + 0.6912D4 * t462 * x - 0.864D3 * t
     #94 + 0.432D3 * t178 + 0.864D3 * t100 + 0.5184D4 * t195 + 0.3024D4 
     #* t205 - 0.648D3 * t218 + 0.972D3 * t225 - 0.648D3 * t239 + 0.540D
     #3 * t246 + 0.1080D4 * t406 * t10 - 0.1296D4 * t399 * t10
      t488 = L * t6
      t490 = L * t14
      t492 = L * t5
      t494 = L * x
      t496 = t68 * t6
      t498 = t68 * t14
      t500 = t68 * t5
      t502 = t68 * x
      t513 = 0.648D3 * t370 * t10 - 0.9078D4 * t488 - 0.2280D4 * t490 - 
     #0.3888D4 * t492 - 0.10686D5 * t494 - 0.2988D4 * t496 - 0.180D3 * t
     #498 - 0.576D3 * t500 - 0.3384D4 * t502 + 0.12966D5 * L * t10 + 0.3
     #564D4 * t68 * t10 + 0.21165D5 * t10 + 0.288D3 * t370 + 0.12414D5 *
     # t1 - 0.11412D5 * t93 + 0.1430D4 * t5
      t530 = 0.504D3 * t177 - 0.3456D4 * t462 - 0.27540D5 * t4 - 0.5832D
     #4 * t399 - 0.2376D4 * t406 + 0.864D3 * t430 - 0.3024D4 * t441 - 0.
     #54D2 * t452 - 0.2642D4 * t14 + 0.15840D5 * t127 - 0.19751D5 * t6 +
     # 0.2772D4 * t99 + 0.3564D4 * t68 + 0.12966D5 * L - 0.2160D4 * z2 -
     # 0.648D3 * z3
      t535 = 0.1D1 / x
      t538 = -0.1D1 / t3
      t553 = -0.14939D5 + 0.17921D5 * x + 0.5184D4 * t47 - 0.9396D4 * t5
     #1 + 0.6804D4 * t53 - 0.8856D4 * t55 + t71 - t73 - 0.3600D4 * t74 +
     # 0.8784D4 * t76 - 0.3024D4 * t78 - 0.1008D4 * t80 + 0.4896D4 * t83
      t567 = -0.5760D4 * t85 + 0.4320D4 * t89 - 0.8352D4 * t91 + 0.3456D
     #4 * t95 - 0.3456D4 * t97 + 0.1728D4 * t101 - 0.1728D4 * t103 + 0.5
     #076D4 * t106 + 0.324D3 * t108 - 0.5616D4 * t110 + 0.108D3 * t113 -
     # 0.324D3 * t115 + 0.432D3 * t117
      t582 = -0.54D2 * t120 + 0.162D3 * t122 - 0.216D3 * t124 + 0.54D2 *
     # t129 - 0.162D3 * t131 + 0.216D3 * t133 - 0.3456D4 * t264 + 0.3456
     #D4 * t268 + 0.7344D4 * t273 - 0.108D3 * t293 + 0.324D3 * t295 - 0.
     #432D3 * t297 - 0.5184D4 * t301
      t596 = 0.4752D4 * t310 - 0.13932D5 * t312 + 0.3564D4 * t314 + 0.25
     #20D4 * t316 + 0.648D3 * t318 + 0.2592D4 * t320 - 0.3672D4 * t326 +
     # 0.216D3 * t288 - 0.14304D5 * t331 + 0.18246D5 * t333 - 0.1998D4 *
     # t335 + 0.3588D4 * t338 + 0.18840D5 * t7
      t612 = -0.21828D5 * t15 + 0.6516D4 * t18 - 0.18912D5 * t21 + 0.144
     #D3 * t346 + 0.8172D4 * t348 + 0.756D3 * t350 - 0.10872D5 * t352 + 
     #0.7344D4 * t50 + 0.216D3 * t105 - 0.216D3 * t112 - 0.720D3 * t371 
     #+ 0.108D3 * t119 - 0.108D3 * t128
      t626 = -0.2106D4 * t375 + 0.6318D4 * t377 - 0.2376D4 * t379 - 0.93
     #6D3 * t383 - 0.4896D4 * t389 + 0.5760D4 * t391 + 0.8352D4 * t394 -
     # 0.2448D4 * t2 + 0.4896D4 * t82 - 0.3348D4 * t400 - 0.324D3 * t402
     # + 0.3888D4 * t404 + 0.7020D4 * t407
      t641 = -0.324D3 * t409 - 0.6480D4 * t411 + 0.720D3 * t413 - 0.4320
     #D4 * t415 - 0.9420D4 * t488 + 0.10752D5 * t490 - 0.3096D4 * t492 +
     # 0.9456D4 * t494 - 0.1224D4 * t496 + 0.1440D4 * t498 - 0.1080D4 * 
     #t500 + 0.2088D4 * t502 - 0.7692D4 * t1
      t655 = 0.2448D4 * t93 - 0.6783D4 * t5 + 0.15384D5 * t4 - 0.216D3 *
     # t399 - 0.216D3 * t406 + 0.21575D5 * t14 - 0.4896D4 * t127 - 0.177
     #74D5 * t6 - 0.1224D4 * t99 - 0.1224D4 * t68 - 0.7692D4 * L + 0.244
     #8D4 * z2 + 0.432D3 * z3
      EggNNLO = (t49 + t87 + t126 + t162 + t198 + t234 + t272 
     $ + t306 + t337 +
     # t365 + t393 + t423 + t459 + t484 + t513 + t530) * t535 * t538 / t
     #24 / 0.48D2 + (t553 + t567 + t582 + t596 + t612 + t626 + t641 + t6
     #55) * t538 * t535 * NF / 0.1296D4

      endif
      !print*,EggNNLO,whichpart
      end

c=========================================================================	

      double precision function ggreg_exact_NLO(z,lambda,QQQ)
      implicit none 
      double precision z,lambda,QQQ
      double precision lambda_limit,born_squared
      double precision hard_ampl,pgg,collinear,hard,ggreg_effective
      double complex real_ggg_ampl1,real_ggg_ampl2,real_ggg_ampl3
      double complex real_ggg_ampl4
      double complex sum_over_quarks,sborn_mass
      external Aq1,Aq2a,Aq2b,Aq2c
	double precision L, Lt, Lr, NF
      common /xsection/ L, Lt, Lr, NF

cc     regular part of NLO Real corrections with massive quarks

cc      ggreg_nlo = 1/2 * Nc * as/Pi * 
cc               [ z^4 S_q{ S_i |real_ggg_ampl_i|^2  } - (1-z+z^2) * 2 * S_q {|born_q|^2} ]
cc               -------------------------------------------------------------------------
cc                           z * (1-z) * lambda * (1-lambda)

c     sum_over_quarks: sums over all massive quarks the function
c     that is passed to it as its first argument and it also 
c     multiplies by a normalization factor Wq(i)*3d0/32d0/QQQ**2
c     which is tau_q*3/32/m_higgs^2 
        
         !call test_limits(QQQ)

         !call test_hard(QQQ)
	real_ggg_ampl1 =sum_over_quarks(Aq1,z,lambda,QQQ) 
	real_ggg_ampl2 =sum_over_quarks(Aq2a,z,lambda,QQQ)
	real_ggg_ampl3 =sum_over_quarks(Aq2b,z,lambda,QQQ)
	real_ggg_ampl4 =sum_over_quarks(Aq2c,z,lambda,QQQ)   
	hard_ampl = abs(real_ggg_ampl1)**2 + 
     #		abs(real_ggg_ampl2)**2 +
     #		abs(real_ggg_ampl3)**2 +
     #		abs(real_ggg_ampl4)**2
      
	born_squared = abs(sborn_mass(QQQ))**2  
      
	lambda_limit = (1d0-z+z**2)**2   *   born_squared
	hard =  3d0 *(1d0/2d0*z**4 * hard_ampl - lambda_limit ) 
     #              /z/(1d0-z)/lambda/(1d0-lambda)  
      !below: the regular piece coming from the integrated collinear counterterm
      !       and the renormalized PDF 
	pgg =1d0/z + z*(1d0-z) - 2d0
      
	collinear = born_squared  * 
     #                  ( 
     #                  6d0 * (pgg * dlog( (1d0-z)**2/z ) 
     #                          - dlog(z)/(1d0-z) 
     #                          )
     #                  -6d0*L*pgg
     #                  )
      
	ggreg_exact_NLO = hard + collinear  
c	ggreg_exact_NLO = collinear + born_squared*11d0/2d0*(z-1)**3/z          

c     test_limits compares the 1/2* z^4 * Sum_q{ | real_ggg_ampl1 |^2 } 
c     with (1-z+z^2) * born_ampl() 
c     at z=0.3, lambda=1e-10, and also lambda=1- 1e-10
c      call test_limits(QQQ)
      end

c====================================================================
c
c		qgreg
c
c====================================================================	

      double precision function qgreg(z,lambda,QQQ,wlo)
      implicit none 
      double precision QQQ,qgreg_NLO_exact
	double precision qg_n1_reg,qg_n2_reg
      double precision z,lambda
      integer wlo
          double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO
          double precision WC2NNLO
          common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
	integer effective_theory_flag
	common /common_eff_theory_flag/ effective_theory_flag
c -------
	
	if (effective_theory_flag.eq.0) then 
		select case (wlo)
		case(0)
			qgreg = 0d0
		case(1)
			qgreg = qgreg_NLO_exact(z,lambda,QQQ)
     #				+ WC0NLO * qg_n1_reg(z) 
		case(2)
			qgreg =  WC1NNLO * qg_n1_reg(z)
     #				+ WC0NNLO * qg_n2_reg(z)
		end select
	elseif (effective_theory_flag.eq.1) then
		select case (wlo)
		case(0)
			qgreg =   0d0
		case(1)
			qgreg =   WC0NLO * qg_n1_reg(z) 
		case(2)
			qgreg = WC1NNLO * qg_n1_reg(z)
     #				+ WC0NNLO * qg_n2_reg(z)
		end select

	endif
      end


c=========================================================================	

	double precision function qgreg_NLO_exact(z,lambda,QQQ)
      implicit none 
      double precision z,QQQ,lambda
      double precision qgreg_effective
	double precision L, Lt, Lr,NF
	double precision pi, z2, z3
	common /xsection/ L, Lt, Lr, NF 
      common /consts/ pi, z2, z3
	double complex sum_Aqqgh,sborn_mass
	double precision Cf,Pgq,born_squared,ysp
	double precision term1,term2,sum_Aqqgh_lambda

	Cf= 4d0/3d0
	Pgq = Cf/2d0*(1d0+(1d0-z)**2)/z
	born_squared = abs(sborn_mass(QQQ))**2
	ysp = -(1d0-z)*(1d0-lambda)
	sum_Aqqgh_lambda=abs(sum_Aqqgh(1d0/ysp,QQQ))**2
		
	term1 = born_squared * (Cf/2d0*z 
     $				- Pgq * dlog(z/(1-z)**2)
     $				- Pgq * L) !L=log(muf**2/mH**2)
	term2 = (
     $			sum_Aqqgh_lambda * (1d0+(1d0-z)**2*lambda)/z
     $			- born_squared     * (1d0+(1d0-z)**2)/z 
     $			)
     $			/(1d0-lambda)
	qgreg_NLO_exact =  (term1+term2)
	
		   
      end



c=========================================================================	
	double precision function qg_n1_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3
	z4=1.082323234d0
	

	t1 = x ** 2
      t4 = 0.1D1 / x
      t5 = (t1 - 0.2D1 * x + 0.2D1) * t4
      t12 = log(x)
      t16 = log(0.1D1 - x)
      t19 = -0.2D1 / 0.3D1 * t5 * L - (t1 - 0.6D1 * x + 0.3D1) * t4 / 0.
     #3D1 - 0.2D1 / 0.3D1 * t5 * t12 + 0.4D1 / 0.3D1 * t5 * t16


	qg_n1_reg = t19	
	
	end
	
	
	
	
c=========================================================================	
	double precision function qg_n2_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3
	double precision Li2,Li3,S12

		
	z4=1.082323234d0
	t1 = x ** 2
      t4 = t1 * x
      t7 = 0.1D1 / x
      t13 = 0.784D3 * t4
      t17 = log(0.1D1 - x)
      t25 = log(x)
      t26 = t25 ** 2
      t33 = Li3(x)
      t50 = 0.2D1 * x
      t52 = (t1 - t50 + 0.2D1) * t7
      t53 = t17 ** 2
      t59 = 0.33D2 * t1
      t61 = (0.4D1 * t4 + 0.222D3 * x + 0.166D3 + t59) * t7
      t62 = Li2(-x)
      t66 = (t1 + t50 + 0.2D1) * t7
      t67 = S12(-x)
      t74 = S12(x)
      t77 = Li3(t1)
      t80 = S12(t1)
      t95 = Li2(x)
      t104 = t52 * NF
      t118 = t52 * t17
      t121 = L ** 2
      t129 = t52 * t53
      t133 = t25 * t17
      t134 = t52 * t133
      t142 = 0.418D3 * x
      t149 = -(-0.144D3 * t1 - 0.221D3 + 0.738D3 * x + 0.292D3 * t4) * t
     #7 * z2 / 0.27D2 - (0.14796D5 * x + 0.3834D4 * t1 + t13 - 0.21295D5
     #) * t7 * t17 / 0.162D3 + (0.226D3 * t4 + 0.1464D4 * x - 0.234D3 * 
     #t1 - 0.837D3) * t7 * t26 / 0.54D2 + (0.339D3 * t1 + 0.302D3 + 0.47
     #4D3 * x) * t7 * t33 / 0.9D1 + (-0.22042D5 + 0.26424D5 * x + 0.2464
     #D4 * t4 + 0.7143D4 * t1) * t7 * t25 / 0.324D3 - (0.142D3 * x + 0.1
     #45D3 * t1 + 0.108D3) * t7 * t26 * t25 / 0.54D2 + 0.367D3 / 0.54D2 
     #* t52 * t53 * t17 - t61 * t62 / 0.27D2 + 0.8D1 * t66 * t67 - (0.26
     #9D3 * t1 + 0.614D3 * x + 0.74D2) * t7 * t74 / 0.9D1 + t66 * t77 / 
     #0.2D1 - 0.2D1 * t66 * t80 + t7 * (-0.2592D4 + 0.111D3 * t1 + 0.288
     #D3 * t4 + 0.2278D4 * x) * t53 / 0.36D2 + (0.2605D4 - 0.711D3 * t1 
     #- 0.876D3 * x + 0.148D3 * t4) * t7 * t95 / 0.54D2 + 0.2D1 / 0.9D1 
     #* (0.46D2 + 0.45D2 * t1 - 0.81D2 * x) * t7 * z3 + (-0.2D1 / 0.9D1 
     #* t104 + (0.91D2 * t1 + 0.92D2 * x - 0.147D3 + 0.36D2 * t4) * t7 /
     # 0.18D2 - 0.2D1 / 0.9D1 * (0.28D2 * t1 + 0.25D2 * x + 0.27D2) * t7
     # * t25 + 0.31D2 / 0.9D1 * t118) * t121 + ((0.29D2 - 0.38D2 * x + 0
     #.19D2 * t1) * t7 * t25 / 0.27D2 + t129 / 0.18D2 + t52 * t26 / 0.9D
     #1 - 0.2D1 / 0.9D1 * t134 - (0.9D1 * t1 - 0.16D2 * x + 0.13D2) * t7
     # * t17 / 0.9D1 + (0.265D3 - t142 + 0.179D3 * t1) * t7 / 0.162D3) *
     # NF
      t152 = (t1 - 0.6D1 * x + 0.3D1) * t7
      t154 = t52 * t25
      t208 = log(x + 0.1D1)
      t209 = t25 * t208
      t227 = (t104 / 0.3D1 - 0.11D2 / 0.2D1 * t52) * Lr + ((0.31D2 - 0.2
     #2D2 * x + 0.29D2 * t1) * t7 / 0.54D2 - t154 / 0.9D1 + 0.4D1 / 0.9D
     #1 * t118) * NF + (-0.19549D5 + 0.10602D5 * x + 0.4293D4 * t1 + t13
     #) * t7 / 0.324D3 + 0.2D1 / 0.9D1 * (0.62D2 + 0.89D2 * t1 + 0.128D3
     # * x) * t7 * z2 + (t59 + 0.1470D4 * x - 0.1080D4 + 0.400D3 * t4) *
     # t7 * t25 / 0.54D2 - (t142 + 0.72D2 * t4 - 0.489D3 + 0.101D3 * t1)
     # * t7 * t17 / 0.9D1 + 0.106D3 / 0.9D1 * t134 - 0.2D1 * t66 * t209 
     #- 0.2D1 / 0.9D1 * (0.46D2 + 0.162D3 * x + 0.81D2 * t1) * t7 * t95 
     #- (0.64D2 * x + 0.54D2 + 0.67D2 * t1) * t7 * t26 / 0.9D1 - 0.31D2 
     #/ 0.3D1 * t129 - 0.2D1 * t66 * t62
      t265 = t208 ** 2
      t282 = ((t152 / 0.6D1 + t154 / 0.3D1 - 0.2D1 / 0.3D1 * t118) * NF 
     #- 0.11D2 / 0.4D1 * t152 - 0.11D2 / 0.2D1 * t154 + 0.11D2 * t118) *
     # Lr + (-0.199423D6 + 0.6148D4 * t4 + 0.176196D6 * x + 0.10743D5 * 
     #t1) * t7 / 0.1944D4 + t227 * L + 0.107D3 / 0.18D2 * t52 * t26 * t1
     #7 - 0.115D3 / 0.9D1 * t52 * t53 * t25 + t52 * t17 * t95 + 0.4D1 * 
     #t66 * t62 * t208 - 0.4D1 * t66 * t25 * t62 - 0.4D1 * t66 * t208 * 
     #t95 - (0.214D3 + 0.446D3 * x + 0.281D3 * t1) * t7 * t25 * t95 / 0.
     #9D1 - t61 * t209 / 0.27D2 - (-0.5935D4 + 0.4956D4 * x + 0.652D3 * 
     #t4 + 0.363D3 * t1) * t7 * t133 / 0.54D2 - 0.3D1 * t66 * t26 * t208
     # + 0.2D1 * t66 * t25 * t265 + 0.4D1 / 0.9D1 * (0.32D2 * t1 + 0.13D
     #2 + 0.35D2 * x) * t7 * z2 * t25 + 0.6D1 * t66 * z2 * t208 - 0.59D2
     # / 0.9D1 * t52 * t17 * z2
      t283 = t149 + t282

	qg_n2_reg = t283
	end


c====================================================================
c
c		qqbreg
c
c====================================================================	

      double precision function qqbreg(z,QQQ,wlo)
      implicit none 
      double precision QQQ,qqbreg_NLO_exact
	double precision qqb_n1_reg,qqb_n2_reg
      double precision z
      integer wlo
          double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO
          double precision WC2NNLO
          common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
	integer effective_theory_flag
	common /common_eff_theory_flag/ effective_theory_flag
c -------
	
	if (effective_theory_flag.eq.0) then 
		select case (wlo)
		case(0)
			qqbreg = 0d0
		case(1)
			qqbreg = qqbreg_NLO_exact(z,QQQ)
     #				+ WC0NLO * qqb_n1_reg(z) 
		case(2)
			qqbreg =  WC1NNLO * qqb_n1_reg(z)
     #				+ WC0NNLO * qqb_n2_reg(z)
		end select
	elseif (effective_theory_flag.eq.1) then
		select case (wlo)
		case(0)
			qqbreg =   0d0
		case(1)
			qqbreg =   WC0NLO * qqb_n1_reg(z) 
		case(2)
			qqbreg = WC1NNLO * qqb_n1_reg(z)
     #				+ WC0NNLO * qqb_n2_reg(z)
		end select

	endif
      end

c=========================================================================	

      double precision function qqbreg_NLO_exact(z,QQQ)
      implicit none 
      double precision z
      double precision QQQ
	double complex sum_Aqqgh
	qqbreg_NLO_exact =  32d0/27d0 * (1d0-z)**3 /z
     $			*abs(sum_Aqqgh(z,QQQ))**2

      end


c=========================================================================	
	double precision function qqb_n1_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3
	z4=1.082323234d0
	

	t1 = x - 0.1D1
      t2 = t1 ** 2
      t7 = -0.32D2 / 0.27D2 * t2 * t1 / x
	
	qqb_n1_reg = t7
	
	end
c=========================================================================	
	double precision function qqb_n2_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3	
	double precision Li2,Li3,S12
	z4=1.082323234d0
	
	t1 = x ** 2
      t4 = 0.32D2 / 0.27D2 + 0.32D2 / 0.9D1 * t1 + 0.16D2 / 0.27D2 * x
      t5 = Li2(-x)
      t8 = (x + 0.2D1) ** 2
      t9 = 0.1D1 / x
      t10 = t8 * t9
      t11 = log(x)
      t15 = x - 0.1D1
      t20 = L ** 2
      t22 = t1 * x
      t30 = t15 ** 2
      t32 = t30 * t15 * t9
      t33 = log(-t15)
      t67 = t9 * t33
      t70 = Li2(x)
      t73 = t11 ** 2
      t87 = (t1 + 0.2D1 * x + 0.2D1) * t9
      t89 = log(x + 0.1D1)
      t99 = t89 ** 2
      t116 = t33 ** 2
      t120 = t4 * t5 + (-0.4D1 / 0.9D1 * t11 * t10 + 0.8D1 / 0.9D1 * (x 
     #+ 0.3D1) * t15 * t9) * t20 + (0.16D2 / 0.81D2 * (0.4D1 * t22 - 0.3
     #D1 - 0.12D2 * t1 + 0.15D2 * x) * t9 * t11 - 0.32D2 / 0.81D2 * t32 
     #* t33 + 0.8D1 / 0.243D3 * (0.41D2 * t1 - 0.88D2 * x + 0.23D2) * t1
     #5 * t9) * NF + (0.16D2 / 0.27D2 * t32 * NF - 0.88D2 / 0.9D1 * t32)
     # * Lr + (0.2D1 / 0.81D2 * t15 * (0.263D3 * x + 0.459D3) * t9 + 0.1
     #6D2 / 0.9D1 * t10 * z2 - 0.4D1 / 0.81D2 * (-0.141D3 * t1 + 0.64D2 
     #* t22 + 0.24D2 * x + 0.108D3) * t9 * t11 + 0.32D2 / 0.81D2 * t15 *
     # (0.8D1 * t1 - 0.25D2 * x - 0.19D2) * t67 - 0.16D2 / 0.9D1 * t10 *
     # t70 - 0.4D1 / 0.9D1 * t10 * t73) * L + 0.8D1 / 0.81D2 * (0.10D2 *
     # t22 + 0.12D2 - 0.87D2 * t1 + 0.42D2 * x) * t9 * t70 - 0.16D2 / 0.
     #27D2 * t87 * t5 * t89 + 0.8D1 / 0.9D1 * t87 * t11 * t5 + 0.4D1 / 0
     #.9D1 * t87 * t73 * t89 - 0.8D1 / 0.27D2 * t87 * t99 * t11 - 0.8D1 
     #/ 0.3D1 * t10 * t11 * t70 + 0.4D1 / 0.81D2 * t15 * (0.384D3 * t1 -
     # 0.967D3 * x - 0.75D2) * t67 - 0.32D2 / 0.81D2 * t15 * (0.13D2 * t
     #1 - 0.35D2 * x - 0.14D2) * t9 * t116
      t141 = S12(-x)
      t151 = S12(x)
      t156 = Li3(-x)
      t159 = Li3(x)
      t180 = -0.8D1 / 0.27D2 * t87 * z2 * t89 + 0.8D1 / 0.9D1 * t10 * z2
     # * t11 - 0.2D1 / 0.81D2 * (0.135D3 - 0.2111D4 * t1 + 0.1448D4 * x 
     #+ 0.768D3 * t22) * t9 * t11 + 0.16D2 / 0.81D2 * (0.5D1 - 0.102D3 *
     # t1 + 0.75D2 * x + 0.47D2 * t22) * t9 * z2 - 0.16D2 / 0.27D2 * t87
     # * t141 - 0.8D1 / 0.81D2 * (0.27D2 + 0.44D2 * t22 + 0.39D2 * x - 0
     #.81D2 * t1) * t9 * t73 - 0.32D2 / 0.9D1 * t10 * t151 + t4 * t11 * 
     #t89 - 0.8D1 / 0.9D1 * t87 * t156 + 0.32D2 / 0.9D1 * t10 * t159 - 0
     #.4D1 / 0.81D2 * t15 * (0.651D3 * t1 - 0.1661D4 * x + 0.241D3) * t9
     # - 0.4D1 / 0.27D2 * t10 * t73 * t11 - 0.16D2 / 0.27D2 * t87 * z3 +
     # 0.16D2 / 0.81D2 * t15 * (0.37D2 * t1 - 0.101D3 * x - 0.44D2) * t6
     #7 * t11
      t181 = t120 + t180

	qqb_n2_reg = t181
	end

c====================================================================
c
c		qqreg
c
c====================================================================		

      double precision function qqreg(z,wlo)
      implicit none 
	double precision qq_n2_reg
      double precision z
      integer wlo
          double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO
          double precision WC2NNLO
          common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
	integer effective_theory_flag
	common /common_eff_theory_flag/ effective_theory_flag
c -------
	
	if (effective_theory_flag.eq.0) then 
		select case (wlo)
		case(0)
			qqreg = 0d0
		case(1)
			qqreg = 0d0 
		case(2)
			qqreg =   WC0NNLO * qq_n2_reg(z)
		end select
	elseif (effective_theory_flag.eq.1) then
		select case (wlo)
		case(0)
			qqreg =   0d0
		case(1)
			qqreg =   0d0 
		case(2)
			qqreg =  WC0NNLO * qq_n2_reg(z)
		end select

	endif
      end



	
c=========================================================================	
	double precision function qq_n2_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3	
	double precision Li2,Li3,S12

	t2 = (x + 0.2D1) ** 2
      t3 = 0.1D1 / x
      t4 = t2 * t3
      t5 = log(x)
      t9 = x - 0.1D1
      t10 = (x + 0.3D1) * t9
      t14 = L ** 2
      t16 = Li2(x)
      t19 = t5 ** 2
      t22 = x ** 2
      t23 = 0.5D1 * t22
      t29 = log(-t9)
      t30 = t3 * t29
      t37 = (0.5D1 * x + 0.17D2) * t9
      t48 = 0.4D1 * x
      t57 = Li3(x)
      t60 = S12(x)
      t68 = (t22 - 0.2D1 * x + 0.2D1) * t3
      t90 = t29 ** 2
      t108 = (-0.4D1 / 0.9D1 * t4 * t5 + 0.8D1 / 0.9D1 * t10 * t3) * t14
     # + (-0.16D2 / 0.9D1 * t4 * t16 - 0.4D1 / 0.9D1 * t4 * t19 + 0.4D1 
     #/ 0.9D1 * (-0.12D2 + t23 + 0.8D1 * x) * t3 * t5 - 0.32D2 / 0.9D1 *
     # t10 * t30 + 0.16D2 / 0.9D1 * t4 * z2 + 0.2D1 / 0.3D1 * t37 * t3) 
     #* L - 0.16D2 / 0.27D2 * (0.17D2 * x + t23 + 0.19D2) * t3 * t5 * t1
     #6 - 0.8D1 / 0.9D1 * (t48 + t22 - 0.6D1) * t3 * t16 + 0.8D1 / 0.27D
     #2 * (0.46D2 * x + 0.50D2 + 0.13D2 * t22) * t3 * t57 - 0.32D2 / 0.9
     #D1 * t4 * t60 - 0.4D1 / 0.27D2 * t4 * t19 * t5 - 0.4D1 / 0.27D2 * 
     #t68 * t19 * t29 + 0.4D1 / 0.27D2 * (0.26D2 * x - 0.18D2 + 0.9D1 * 
     #t22) * t3 * t19 - 0.16D2 / 0.3D1 * t10 * t30 * t5 + 0.8D1 / 0.9D1 
     #* t4 * z2 * t5 + 0.2D1 / 0.27D2 * (0.124D3 * x + 0.69D2 * t22 - 0.
     #177D3) * t3 * t5 + 0.32D2 / 0.9D1 * t10 * t3 * t90 - 0.4D1 / 0.3D1
     # * t37 * t30 - 0.8D1 / 0.9D1 * (-0.6D1 + 0.3D1 * t22 + t48) * t3 *
     # z2 - 0.8D1 / 0.27D2 * t68 * z3 + 0.4D1 / 0.27D2 * (0.27D2 * x + 0
     #.160D3) * t9 * t3
	qq_n2_reg = t108
	end

c====================================================================
c
c		q1q2reg
c
c====================================================================	

      double precision function q1q2reg(z,wlo)
      implicit none 
	double precision q1q2_n2_reg
      double precision z
      integer wlo
          double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO
          double precision WC2NNLO
          common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
	integer effective_theory_flag
	common /common_eff_theory_flag/ effective_theory_flag
c -------
	
	if (effective_theory_flag.eq.0) then 
		select case (wlo)
		case(0)
			q1q2reg = 0d0
		case(1)
			q1q2reg =  0d0 
		case(2)
			q1q2reg = WC0NNLO * q1q2_n2_reg(z)
		end select
	elseif (effective_theory_flag.eq.1) then
		select case (wlo)
		case(0)
			q1q2reg =   0d0
		case(1)
			q1q2reg =   0d0
		case(2)
			q1q2reg = WC0NNLO * q1q2_n2_reg(z)
		end select

	endif
      end


c=========================================================================	
      doubleprecision function q1q2_n2_reg(x)
	implicit double precision (t)
      double precision pi, z2, z3, L, Lt, Lr,x
      double precision Li2, Li3, S12, NF
      double precision s1,s2,s3,s4,s5,s6,s7,s8,s9,s10
      external Li2, Li3, S12
      common /xsection/ L, Lt, Lr, NF 
      common /consts/ pi, z2, z3       
      q1q2_n2_reg=((-4.D0/9.D0*(x+2)**2/x*dlog(x)
     #+8.D0/9.D0*(x+3)*(x-1)/x)
     #     *L**2
     #+(-16.D0/9.D0*(x+2)**2/x*Li2(x)-4.D0/9.D0*(x+2)**2/x*dlog(x)**2+4.
     #D0/9.D0*(-12+5*x**2+8*x)/x*dlog(x)-32.D0/9.D0*(x+3)*(x-1)/x*dlog(-
     #x+1)+16.D0/9.D0*(x+2)**2/x*z2+2.D0/3.D0*(5*x+17)*(x-1)/x)*L-8.D0/3
     #.D0*(x+2)**2/x*dlog(x)*Li2(x)-8.D0/9.D0*(4*x+x**2-6)/x*Li2(x)+32.D
     #0/9.D0*(x+2)**2/x*Li3(x)-32.D0/9.D0*(x+2)**2/x*S12(x)-4.D0/27.D0*(
     #x+2)**2/x*dlog(x)**3+8.D0/9.D0*(4*x-3+x**2)/x*dlog(x)**2-16.D0/3.D
     #0*(x+3)*(x-1)/x*dlog(-x+1)*dlog(x)+8.D0/9.D0*(x+2)**2/x*z2*dlog(x)
     #+2.D0/9.D0*(44*x-59+29*x**2)/x*dlog(x)+32.D0/9.D0*(x+3)*(x-1)/x*dl
     #og(-x+1)**2-4.D0/3.D0*(5*x+17)*(x-1)/x*dlog(-x+1)-8.D0/9.D0*(-6+3*
     #x**2+4*x)/x*z2+2.D0/9.D0*(11*x+105)*(x-1)/x)!*alphas**2
        return
      end	

c====================================================================
c====================================================================
c	
c			auxiliary functions 
c
c====================================================================
c====================================================================
C     returns Sum_q born_ampl(tau_q)  
      double complex function sborn_mass(QQQ)
      implicit none
      integer i
      double precision QQQ

      double complex res,brn_q_ep0,xxx
      !double precision ZZq
      
      double precision double_mq(100),Yq(100),Gq(100)
      double complex Wq(100),Xq(100),Mq_square_complex(100)
      integer  number_of_quarks, qscheme(100)
      common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,Gq,
     &     qscheme,number_of_quarks
	
      
cc      xxx=dcmplx(0d0,0d0)
      res = dcmplx(0d0,0d0)    
      do i=1,number_of_quarks
        res = res + Yq(i)*brn_q_ep0(Xq(i))*Wq(i)**2/64d0*(-3d0/4d0)
cc        print*,i,res,1d0-abs(xxx)**2/abs(res)**2
cc        xxx=res
      enddo  
    
      sborn_mass = res
      end 

c====================================================================

C     returns Sum_q born_ampl(tau_q)  where the sum runs over HEAVY QUARKS
c	HEAVY is defined to be larger than the heavy_quark_threshold below
      double complex function born_sum_heavy(QQQ)
      implicit none
      integer i
      double precision QQQ

      double complex res,brn_q_ep0,xxx
      !double precision ZZq
	
      double precision double_mq(100),Yq(100),Gq(100)
      double complex Wq(100),Xq(100),Mq_square_complex(100)
      integer  number_of_quarks, qscheme(100)
      common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,Gq,
     &     qscheme,number_of_quarks

      
      double precision heavy_quark_threshold
	
      heavy_quark_threshold=25d0

      res = dcmplx(0d0,0d0)    
      do i=1,number_of_quarks
        if (abs(Mq_square_complex(i)).gt.heavy_quark_threshold) then 
		!print*,"quark ",i," is heavy "
		res = res + Yq(i)*brn_q_ep0(Xq(i))*Wq(i)**2/64d0*(-3d0/4d0)
	  endif
      enddo  

c      print*, "Born_sum_heavy:",res
      born_sum_heavy = res
      end  
c====================================================================

C     returns born of Passarino, Actis, Sturm, Ucciratti 	
c	http://arxiv.org/abs/arXiv:0809.1301
c	We use their deltaEWK interpolated from their grid, and we 
c	need the born with top only, and with the values of top 
c	used there. This function is only used in 
c	calculate_wilson_coefficients @ higgs.F
      double complex function born_pass(QQQ)
      implicit none
      double precision QQQ,mtop_pass
	double complex brn_q_ep0,Wq,Xq
	
	mtop_pass = 170.9d0
	Wq = dcmplx(4d0*mtop_pass**2/QQQ**2,0d0)
	Xq = -Wq/(sqrt(1d0-Wq)+1d0)**2
	
	born_pass = brn_q_ep0(Xq)*Wq**2/64d0*(-3d0/4d0)
	!print*, born_pass
      end  


c====================================================================


C     returns Sum_q virtual_ampl(tau_q)  
      double complex function svirtual_mass(QQQ)
      implicit none
      integer i
      double precision QQQ
      
      double complex res,twol_q_fin,twol_q_fin_bon,lmmu
      double precision myrealpart
      
      double precision double_mq(100),Yq(100),Gq(100)
      double complex Wq(100),Xq(100),Mq_square_complex(100)
      integer  number_of_quarks, qscheme(100)
      common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,Gq,
     &     qscheme,number_of_quarks
	
      double precision tau,Etot,muf,mur
      character*60 collider
      common /toHiggsF/ tau,Etot,muf,mur,collider
      
      double complex x,w,bon,bab,har,harlaender

      
      !: note that we use here twol_q_fin_bon instead of twol_q_fin
	!: the difference is described in massive_ampls.F
	!: twol_q_fin_bon is known to have numerical (cancelation) issues for
	!: very heavy (mq>8TeV) quarks

      res = dcmplx(0d0,0d0)    
      do i=1,number_of_quarks
         
         if (myrealpart(Xq(i)).gt.0.9999) then 
            print*,"[svirtual_mass]: warning, x_q is too large(",
     #xq,") for quark ",i
         endif
         lmmu = log(Mq_square_complex(i)/mur**2)
         res = res + Yq(i)*twol_q_fin_bon(Xq(i),qscheme(i),lmmu)
      enddo  
      svirtual_mass = res
      
c      do i=1,200
c         w = dcmplx(0.01d0 + i*0.01d0,0d0)
c         x = -1d0/w/(sqrt(1d0-1d0/w)+1d0)**2 + dcmplx(0d0,1d-15)
c         
c         bon = twol_q_fin_bon(x)
c         bab = twol_q_fin(x)
c         har = harlaender(x,w)
c
c         print*,123,dreal(w),dreal(bon),dimag(bon),dreal(bab),dimag(bab)
c         print*,dreal(w),dreal(bon),dimag(bon),dreal(har),dimag(har)
c      end do
c      STOP

      end  

c====================================================================

C     returns Sum_q Aqqgh(tau_q)  necessary for reg_qqbar
      double complex function sum_Aqqgh(z,QQQ)
      implicit none
      integer i
      double precision QQQ,z
      double complex res,twol_q_fin,mq
      !double precision ZZq
      
      double precision double_mq(100),Yq(100),Gq(100)
      double complex Wq(100),Xq(100),Mq_square_complex(100)
      integer  number_of_quarks, qscheme(100)
      common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,Gq,
     &     qscheme,number_of_quarks
	
      double complex Aqqgh
      
      res = dcmplx(0d0,0d0)    
      do i=1,number_of_quarks
	  mq = sqrt(Mq_square_complex(i))
        res = res + Yq(i)*Aqqgh(z,QQQ,Wq(i),mq)
     #      *Wq(i)*(3d0/4d0)
      enddo  
    
      sum_Aqqgh = res
      end  


c====================================================================
C     returns Sum_q Yq * m_q^2 Aq1(tau,z,lambda)  
      double complex function sum_over_quarks(func,z,lambda,QQQ)
      implicit none
      integer i
      double precision QQQ,z,lambda
      
      double precision double_mq(100),Yq(100),Gq(100)
      double complex Wq(100),Xq(100),Mq_square_complex(100)
      integer  number_of_quarks, qscheme(100)
      common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,Gq,
     &     qscheme,number_of_quarks

      double complex res,func,mq
      !double precision ZZq
      
      
      res = dcmplx(0d0,0d0)    
      do i=1,number_of_quarks
        mq  = sqrt(Mq_square_complex(i)) 
	  res = res + Yq(i)* 
     #      func(z,lambda,mq,QQQ)*
     #      Wq(i)
     #      *3d0/32d0/QQQ**2
      enddo  
    
      sum_over_quarks = res
      end


c==========================================================================
c
c           TESTING SUBROUTINES BELOW - REMOVE BY FINAL RELEASE
c
c--------------------------------------------------------------------------





c     test_limits compares the 1/2* z^4 * Sum_q{ | real_ggg_ampl1 |^2 } 
c     with (1-z+z^2) * born_ampl() 
c     at z=0.3, lambda=1e-10

      subroutine test_limits(QQQ)
      implicit none
      double precision QQQ
      double complex test_limit,test_mq,tau_q,test_born,triaf
      double complex sum_q_A1,sum_q_A2a,sborn_mass
      double complex sum_q_A2b,sum_q_A2c,sum_over_quarks  
      double precision z,lambda,tmp 
      external Aq1,Aq2a,Aq2b,Aq2c 


      


    ! testing whether the lambda->0 are still ok
      print*,"--------   limit testing \n"
      z=0.3d0
      lambda=1.d-10
      
      
       
      sum_q_A1=sum_over_quarks(Aq1,z,lambda,QQQ) 
      sum_q_A2a=sum_over_quarks(Aq2a,z,lambda,QQQ) 
      sum_q_A2b=sum_over_quarks(Aq2b,z,lambda,QQQ) 
      sum_q_A2c=sum_over_quarks(Aq2c,z,lambda,QQQ) 
      tmp = abs(sum_q_A1)**2 + 
     #         abs(sum_q_A2a)**2 +
     #         abs(sum_q_A2b)**2 +
     #         abs(sum_q_A2c)**2

c      test_mq=  dcmplx(172.7d0,0d0)
c      tau_q = 4d0* test_mq**2/QQQ**2
      
c      test_born = 3d0/2d0*tau_q*(
c     #             1d0-0.5d0*(1d0-tau_q)*triaf(test_mq,QQQ**2)
c     #                          ) 
      test_born = sborn_mass(QQQ)  
      test_limit = (1d0-z+z**2)**2*abs(test_born)**2
      print*,"test 1 \t z=",z,"\tlambda=",lambda
      print*,"Real(L=1d-6)=",tmp*z**4/2d0
      print*,"limit       =",test_limit
      
    ! testing whether the lambda ->1 are still ok
      print*,"--------   limit testing \n"
      z=0.03d0
      lambda=1-1d-10
       
      sum_q_A1=sum_over_quarks(Aq1,z,lambda,QQQ) 
      sum_q_A2a=sum_over_quarks(Aq2a,z,lambda,QQQ) 
      sum_q_A2b=sum_over_quarks(Aq2b,z,lambda,QQQ) 
      sum_q_A2c=sum_over_quarks(Aq2c,z,lambda,QQQ) 
      tmp = abs(sum_q_A1)**2 + 
     #         abs(sum_q_A2a)**2 +
     #         abs(sum_q_A2b)**2 +
     #         abs(sum_q_A2c)**2

c      test_mq=  dcmplx(172.7d0,0d0)
c      tau_q = 4d0* test_mq**2/QQQ**2
      
c      test_born = 3d0/2d0*tau_q*(
c     #             1d0-0.5d0*(1d0-tau_q)*triaf(test_mq,QQQ**2)
c     #                          ) 
      test_born = sborn_mass(QQQ)  
      test_limit = (1d0-z+z**2)**2*abs(test_born)**2
      print*,"test 1 \t z=",z,"\tlambda=",lambda
      print*,"Real(L=1d-6)=",tmp*z**4/2d0
      print*,"limit       =",test_limit      
      ! testing whether the lambda ->1 are still ok
      print*,"-------- z->1  limit testing \n"
      z=0.99999d0
      lambda=1-1d-10
       
      sum_q_A1=sum_over_quarks(Aq1,z,lambda,QQQ) 
      sum_q_A2a=sum_over_quarks(Aq2a,z,lambda,QQQ) 
      sum_q_A2b=sum_over_quarks(Aq2b,z,lambda,QQQ) 
      sum_q_A2c=sum_over_quarks(Aq2c,z,lambda,QQQ) 
      tmp = abs(sum_q_A1)**2 + 
     #         abs(sum_q_A2a)**2 +
     #         abs(sum_q_A2b)**2 +
     #         abs(sum_q_A2c)**2

c      test_mq=  dcmplx(172.7d0,0d0)
c      tau_q = 4d0* test_mq**2/QQQ**2
      
c      test_born = 3d0/2d0*tau_q*(
c     #             1d0-0.5d0*(1d0-tau_q)*triaf(test_mq,QQQ**2)
c     #                          ) 
      test_born = sborn_mass(QQQ)  
      test_limit = (1d0-z+z**2)**2*abs(test_born)**2
      print*,"test 1 \t z=",z,"\tlambda=",lambda
      print*,"Real(L=1d-6)=",tmp*z**4/2d0
      print*,"limit       =",test_limit  
c     print*,"QQQ=",QQQ,z,test_limit   
      stop
      
      end        
      
      
    
      subroutine virtual_11_over_2_test()
      implicit none
      double complex twol_q_fin,tau_q,xq,brn_q_ep0,born,two_loop_fin
	double complex twol_q_fin_bon,bonciani
      integer i
      tau_q = dcmplx(0.5d0,0d0)
      
      do i=1,20
		tau_q = 0.5d0 + (i-1.0)*100d0
		xq =  -tau_q/(sqrt(1d0-tau_q)+1d0)**2
		two_loop_fin = twol_q_fin(-xq)/64d0/8d0!*(3d0/4d0)
		born = brn_q_ep0(xq)*tau_q**2/64d0*(-3d0/4d0)
		bonciani = twol_q_fin_bon(xq)
		!print*,"***"
		!print*,"tau=",tau_q," x=",xq
		!print*,"born =",born
c		print*,"tau=",tau_q,"\t2loop=",two_loop_fin
		!print*,"11*4/3*born=",11d0*4d0/3d0*born
c		print*,!"mt=",dble(sqrt(tau_q*120d0**2)/2d0),
c     #	" tau=",tau_q,
      	print*,"tau=",tau_q,"\tbonciani=",bonciani,11d0/2d0*born
      
      enddo
	do i=1,20
		tau_q = tau_q*10d0
		xq =  -tau_q/(sqrt(1d0-tau_q)+1d0)**2
		two_loop_fin = twol_q_fin(-xq)/64d0/8d0!*(3d0/4d0)
		born = brn_q_ep0(xq)*tau_q**2/64d0*(-3d0/4d0)
		bonciani = twol_q_fin_bon(xq)*(-2d0/3d0)
		!print*,"***"
		!print*,"tau=",tau_q," x=",xq
		!print*,"born =",born
c		print*,"tau=",tau_q,"\t2loop=",two_loop_fin
		!print*,"11*4/3*born=",11d0*4d0/3d0*born

      	print*,"tau=",tau_q,"\tbonciani=",bonciani,11d0/2d0*born
      
      enddo
      end

      
