      subroutine matrixelem(vars,wlo,Nmax,xorki,cuba_weight,iternumber)
      implicit none
      INTEGER wlo,imember, Nmax,iternumber
      double precision vars(4)
      character*60 collider, pdfset
      double precision muf, xorki(Nmax),cuba_weight

      double precision x1, x2, tau, x, z, z_one, ris
      double precision deltaWidth, taus,lambda

      double precision  as_local, meas 
      double precision Rplus, Rdelta, Rreg
      double precision pi, QQQ
      double precision Lgg,Lqg,Lqqb,Lqq,Lq1q2
      double precision Lggo,Lqgo,Lqqbo,Lqqo,Lq1q2o
      double precision Lbbo,Lbbbaro,Lbqo,Lbgo,Lqqbar_no_bo
      double precision Lbb,Lbbbar,Lbq,Lbg,Lqqbar_no_b
      double precision Luub,Lddb,Lug,Ldg,Luubo,Lddbo,Lugo,Ldgo
      double precision BranchingRatio, brat, Etot
      double precision yvar,  yplus, yminus
      double precision pref_sgg,pref_sbb
      double precision ris_gg,ris_bb
      
c      --
	double precision L, Lt, Lr,NF
      common /xsection/ L, Lt, Lr, NF 
      common /DeltaWidth/ deltaWidth  
      common /toHiggsF/ tau,Etot,muf,mur,collider

      double precision mur
	
	
      external lumif
	! coefficients 
	double precision c_gg(1:13,0:2)
	double precision c_bb(1:8,0:2)
	double precision ME_coeff
	! channel sectors : eg. ggplus = gg channel plus distribution terms
	! now packed in sect(i), bsect(i) 
	! forking to various calculating functions at ME_coeff function 
	! see below at this file for a detailed listing
	double precision sect(1:13) ! for gluon fusion process
	double precision bsect(1:8)! for b bbar process
	integer ichannel,jprocess
	! Stuff below should be included from alpha_yukawa.inc 
	integer number_of_grids
	parameter(number_of_grids = 100)
	double precision alphaMz(0:number_of_grids)
	double precision alphas(0:number_of_grids)
	double precision yukawa_bb(0:number_of_grids)
	common /alpha_yukawa/ alphaMz,alphas,yukawa_bb
	! till here
	!
      double precision double_mq(100),Yq(100),Gq(100)
      double complex Wq(100),Xq(100),Mq_square_complex(100)
      integer  number_of_quarks, qscheme(100)
      common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,Gq,
     &     qscheme,number_of_quarks
	!:common flags 
	integer ProductionMode
	common /commonflags/ ProductionMode
      !
      double precision Qmin,Qmax
      common /mhWindow/ Qmin,Qmax
	!
      double precision Gamma_ratio, GammaRatio,mh_nom,oldGR
      double precision BWprefactor,BW_factor
      integer nnnlo_approximation_flag
      common /common_nnnlo_approximation_flag/ nnnlo_approximation_flag 
	
      
      
      pi =3.14159265358979324d0
	!35.0309 = Gf*pi/sqrt(2)/288 with the Gf in pb
	! Gf = 1.16637*10^{-5} * 0.389379*10^9 
	pref_sgg = 35.0309d0
	pref_sbb = pi/6d0*0.389379d9
	if (ProductionMode.eq.1) then
		pref_sbb = 0d0
	endif
	if (ProductionMode.eq.2) then
		pref_sgg = 0d0
	endif

      !: determining the virtuality of the higgs from a Breit-Wigner  
      
      yminus = 1d0/pi*datan( (Qmin**2/Etot**2-tau)/
     $                          (deltaWidth*tau) )
      yplus = 1d0/pi*datan( (Qmax**2/Etot**2-tau)/
     $                          (deltaWidth*tau) )

	pref_sgg = pref_sgg*(yplus-yminus) ! Stephans Jacobian
	pref_sbb = pref_sbb*(yplus-yminus) ! Stephans Jacobian
      
      
      yvar = yminus+(yplus-yminus)*vars(3)
      taus = tau
     & + tau*deltaWidth*dtan(pi*yvar)

      QQQ = dsqrt(taus)*Etot
	! Jacobian from transformation
      mh_nom = dsqrt(tau)*Etot
      BWprefactor=BW_factor(QQQ,mh_nom)
      !
      !     EXPERIMENTING WITH TAILS
      !
c      if (dabs(QQQ-mh_nom).gt.0.7d0) then 
c            BWprefactor=BWprefactor/dsin(pi*yvar)**2*mh_nom**4/QQQ**4
c      else
c            BWprefactor=0d0
c      endif
      !
      !
      !
      pref_sgg = pref_sgg* BWprefactor     
      pref_sbb = pref_sbb* BWprefactor
c----- retrieving the precalculated branching ratio   
      brat = BranchingRatio(QQQ)
      
c----- setting the logs L,Lr,Lt 
	!L = log(muf**2/mhiggs**2)
	L  = dlog(muf**2/QQQ**2)
	!Lr = log(mur**2/mhiggs**2)
	Lr = dlog(mur**2/QQQ**2)
	!Lt = log(mhiggs**2/mt**2)
	Lt = dlog(mur**2/double_mq(1)**2)
	NF=5d0
c----- calculating Wq, Xq for every quark
	call calculate_W_X(QQQ)
c----- calculating Wilson coefficients
	call calculate_wilson_coefficients(QQQ,mur)
c---- --- 
      Rplus=1d0
      Rdelta =1d0
      Rreg=1d0
c------------ emptying the coefficients
	do ichannel=0,2
		do jprocess=1,13
			c_gg(jprocess,ichannel)=0d0
		enddo
		do jprocess=1,8
			c_bb(jprocess,ichannel)=0d0
		enddo
	enddo
c------------- setting up the kinematics
	x=vars(1)
	z_one = 1d0
	meas =1/x
	!x1 = x
	!x2 = taus/x1/z_one
	lambda = vars(4)
	x=vars(1)
	z = vars(2)
	meas =1/x
	!x1 = x
	!x2 = taus/x1/z
C---- Evaluate  coefficient functions
	!c_gg(1,*) is the delta term evaluated at z=1
	!c_gg(2-7,*) are the plus/regular terms evaluated at z<1
	!similarly for c_bb
        if (ProductionMode.eq.1) then
!     LO coefficients: we always need these
           c_gg(1,0)=ME_coeff("gg",1,z_one,lambda,QQQ,0)
           do ichannel=2,13
              c_gg(ichannel,0)=ME_coeff("gg",ichannel,z,lambda,QQQ,0)
           enddo
!     If we are at NLO or higher we also need the NLO coeffs
           if (wlo.gt.0) then
              c_gg(1,1)=ME_coeff("gg",1,z_one,lambda,QQQ,1)
              do ichannel=2,13
                 c_gg(ichannel,1)=ME_coeff("gg",ichannel,z,lambda,QQQ,1)
              enddo
           endif
!     If we are at NNLO we also need the NNLO coeffs
           if (wlo.gt.1) then 
              c_gg(1,2)=ME_coeff("gg",1,z_one,lambda,QQQ,2)
              do ichannel=2,13
                 c_gg(ichannel,2)=ME_coeff("gg",ichannel,z,lambda,QQQ,2)
              enddo
           endif
        endif
        
        if (ProductionMode.eq.2) then
! LO coefficients: we always need these
           c_bb(1,0)=ME_coeff("bb",1,z_one,lambda,QQQ,0)
           do ichannel=2,8
              c_bb(ichannel,0)=ME_coeff("bb",ichannel,z,lambda,QQQ,0)
           enddo
! If we are at NLO or higher we also need the NLO coeffs
           if (wlo.gt.0) then
              c_bb(1,1)=ME_coeff("bb",1,z_one,lambda,QQQ,1)
              do ichannel=2,8
                 c_bb(ichannel,1)=ME_coeff("bb",ichannel,z,lambda,QQQ,1)
              enddo
           endif
! If we are at NNLO we also need the NNLO coeffs
           if (wlo.gt.1) then 
              c_bb(1,2)=ME_coeff("bb",1,z_one,lambda,QQQ,2)
              do ichannel=2,8
                 c_bb(ichannel,2)=ME_coeff("bb",ichannel,z,lambda,QQQ,2)
              enddo
           endif
	endif	
        do imember=0,Nmax-1
           
           ris=0d0
           as_local = alphas(imember)
c----------evaluating sect* for the current alphas
           do ichannel=1,13
              sect(ichannel)=	  c_gg(ichannel,0)
     &             + as_local*c_gg(ichannel,1)
     &             + as_local**2*c_gg(ichannel,2)
           enddo
           
           do ichannel=1,8
              bsect(ichannel)=	  c_bb(ichannel,0)
     &             + as_local*c_bb(ichannel,1)
     &             + as_local**2*c_bb(ichannel,2)
           enddo
           
C-------PARTONIC LUMINOSITIES -----------------
           x=vars(1)
           z_one = 1d0
           meas =1/x
           x1 = x
           x2 = taus/x1/z_one
           
           call lumif(collider,x1,x2, imember, Lggo,Lqgo,
     &          Lqqbo,Lqqo,Lq1q2o,
     &          Lbbo,Lbbbaro,Lbqo,Lbgo,Lqqbar_no_bo
     &          ,Luubo,Lddbo,Lugo,Ldgo)
           
           x=vars(1)
           z = vars(2)
           meas =1/x
           x1 = x
           x2 = taus/x1/z
           
           
           call lumif(collider,x1,x2, imember, Lgg,Lqg,
     &          Lqqb,Lqq,Lq1q2,
     &          Lbb,Lbbbar,Lbq,Lbg,Lqqbar_no_b
     &          ,Luub,Lddb,Lug,Ldg)
           
           
           
C-------------------------------------------------------------
C---- ====> gluon gluon fusion         
           ris_gg = meas* (
     $          Lggo*sect(1)
     $          + (Lgg-Lggo)/(1d0-z)*sect(2)
     $          + Lqg*sect(3)
     $          + Lqqb*sect(4)
     $          + Lqq*sect(5)
     $          + Lq1q2*sect(6)
     $          + Lgg*sect(7)
     $          +Luub*sect(8)
     $          +Lddb*sect(9)
     $          +Lug*sect(10)
     $          +Ldg*sect(11)
     $          +Lbg*sect(12)
     $          +Lbbbar*sect(13)
     $          )
C=====> here comes the b - b bar         
           ris_bb = meas* (
     $          Lbbbaro*bsect(1)
     $          +(Lbbbar-Lbbbaro)/(1d0-z)*bsect(2)
     $          + Lbbbar*bsect(3)
     $          + Lbq*bsect(4)
     $          + Lbg*bsect(5)
     $          + Lgg*bsect(6)
     $          + Lqqbar_no_b*bsect(7)
     $          + Lbb*bsect(8)
     $          ) 
C---  Here comes the branching ratio..... 
           
C-----------------------------------------
           ris =	ris_gg*pref_sgg*as_local**2
     $		+
     $		ris_bb*pref_sbb * Yq(2)**2*yukawa_bb(imember)**2/QQQ**2
!     xorki is the result array, defined from 1 to Nmax
           xorki(imember+1)=ris*brat
! bin the central value for invariant mass distribution
           if (imember.eq.0) then
              call binner(QQQ,ris*cuba_weight*brat,iternumber)
           endif
        enddo
        end
      
      
      
      
      
c=========================================================================
c     : ME_coeff is the basic forking function 
      double precision function ME_coeff(process,channel,
     $     z,lambda,QQQ,order)
      implicit none
      character*2 process
      integer channel,order
      double precision z,lambda,QQQ
      double precision gg_me,qgreg,qqbreg,qqreg,q1q2reg
      double precision bbbardelta,bbbarplus,bbbarreg,bqreg,bgreg
      double precision ggreg_bot,qqbreg_bot,bbreg
      double precision lbbbardelta,lbbbarplus,lbbbarreg,lbqreg,lbgreg
      double precision lggreg_bot,lqqbreg_bot,lbbreg
      double precision ewkqqbar,ewkqg,ewkbbbar,ewkbg
      
      double precision K_ewk
      common /commonKewk/ K_ewk
      character*5 whichpart
      
      ME_coeff = 0d0
! gluon fusion coefficients in ggxsections.F
! we note below which channels contribute at each order
      if (process.eq."gg") then 
         select case (channel)
         case(1)                ! gg channel delta terms LO,NLO,NNLO
            whichpart="delt"
            ME_coeff = gg_me(whichpart,z,lambda,QQQ,order)
!     print*,"ME_coeff=",ME_coeff,z,order
         case(2)                ! gg channel plus terms NLO,NNLO
            whichpart="plus"
            ME_coeff = gg_me(whichpart,z,lambda,QQQ,order)
         case(3)                ! qg channel only regular NLO,NNLO
            ME_coeff = qgreg(z,lambda,QQQ,order)
         case(4)                ! qq channel only regular NNLO
            ME_coeff = qqbreg(z,QQQ,order)
         case(5)                ! qqbar channel regular  NLO, NNLO
            ME_coeff = qqreg(z,order)
         case(6)                ! different quarks only regular NNLO
            ME_coeff = q1q2reg(z,order)
         case(7)                ! gg channel regular terms NLO,NNLO
            whichpart="regu"
            ME_coeff = gg_me(whichpart,z,lambda,QQQ,order)
         case(8)                ! u ubar mixed QCD/EWK NLO
            ME_coeff = K_ewk*ewkqqbar(z,lambda,QQQ,order,1)
         case(9)                ! d dbar mixed QCD/EWK NLO
            ME_coeff = K_ewk*ewkqqbar(z,lambda,QQQ,order,2)
         case(10)               ! u g mixed QCD/EWK NLO
            ME_coeff = K_ewk*ewkqg(z,lambda,QQQ,order,1)
         case(11)               ! d g mixed QCD/EWK NLO
            ME_coeff = K_ewk*ewkqg(z,lambda,QQQ,order,2)
         case(12)               ! b g massive mixed QCD/EWK NLO
            ME_coeff = K_ewk*ewkbg(z,lambda,QQQ,order)
         case(13)               ! b bar massive mixed QCD/EWK NLO
            ME_coeff = K_ewk*ewkbbbar(z,lambda,QQQ,order)
         end select
      endif
! b bbar coefficients in bbxsections.F
! note bbbardelta gives the coefficient for mur=muf=m_higgs
! and lbbbardelta the mur/muf dependence
      if (process.eq."bb") then
         select case (channel)
         case(1)                ! b bbar delta terms LO,NLO,NNLO
            ME_coeff = bbbardelta(order) + lbbbardelta(z,order)
         case(2)                ! b bbar plus terms LO,NLO,NNLO
            ME_coeff = bbbarplus(z,order) + lbbbarplus(z,order)
         case(3)                ! b bbar regular terms LO,NLO,NNLO
            ME_coeff = bbbarreg(z,order) + lbbbarreg(z,order)
         case(4)                ! b q regular  NNLO
            ME_coeff = bqreg(z,order) + lbqreg(z,order)
         case(5)                ! b g regular NLO NNLO
            ME_coeff = bgreg(z,order) + lbgreg(z,order)
         case(6)                ! g g regular NNLO
            ME_coeff = ggreg_bot(z,order) + lggreg_bot(z,order)
         case(7)                ! q qbar  regular NNLO
            ME_coeff = qqbreg_bot(z,order) + lqqbreg_bot(z,order)
         case(8)                ! b b regular  NNLO
            ME_coeff = bbreg(z,order) + lbbreg(z,order)
         end select
      endif
      end
      
c=========================================================================

      subroutine binner(QQQ,ff,iternumber)
      implicit none
      double precision QQQ,Qmin,Qmax,binsize,Qbinmin,Qbinmax
      double precision ff
      integer ibin,iternumber,lastiter
      integer number_of_bins
      parameter (number_of_bins=1970)
      double precision my_bins(number_of_bins)
      common /cmybins/ my_bins,lastiter
      
! set to zero if we're in a new iteration
      if (iternumber.ne.lastiter) then
         do ibin=1,number_of_bins
            my_bins(ibin)=0d0
         enddo
      endif
! bin
      lastiter = iternumber
      Qmax=2000d0
      Qmin=30d0
      binsize=(Qmax-Qmin)/number_of_bins
      do ibin=1,number_of_bins
         Qbinmin=Qmin+(ibin-1)*binsize
         Qbinmax=Qmin+ibin*binsize
         if ((QQQ.ge.Qbinmin).and.(QQQ.lt.Qbinmax)) then 
            my_bins(ibin)=my_bins(ibin)+ff
            
         endif
      enddo
      
      end
