      subroutine INTE2(ndim,vars,ncomp,risc,userdata,weight,iternumber)
      implicit none
      INTEGER ndim,ncomp,iternumber,userdata
      double precision vars(ndim), risc(ndim)
	double precision weight
      common /itercom/ iterationnumber
      integer iterationnumber
      
      if (iterationnumber.ne.iternumber) then 
            iterationnumber=iternumber
            print*,". "!,iterationnumber,iternumber
      endif
	call matrixelem(vars,2,ncomp,risc,weight,iternumber)
      end


      subroutine INTE1(ndim,vars,ncomp,risc,userdata,weight,iternumber)
      implicit none
      INTEGER ndim,ncomp,iternumber,userdata
      double precision vars(ndim), risc(ndim)
	double precision weight
      common /itercom/ iterationnumber
      integer iterationnumber
      
      if (iterationnumber.ne.iternumber) then 
            iterationnumber=iternumber
            print*,". "!,iterationnumber,iternumber
      endif
      
	call matrixelem(vars,1,ncomp,risc,weight,iternumber)

      end      


      subroutine INTE0(ndim,vars,ncomp,risc,userdata,weight,iternumber)
      implicit none
      INTEGER ndim,ncomp,iternumber,userdata
      double precision vars(ndim), risc(ndim)
	double precision weight
      common /itercom/ iterationnumber
      integer iterationnumber
      
      if (iterationnumber.ne.iternumber) then 
            iterationnumber=iternumber
            print*,". "!,iterationnumber,iternumber
      endif
	call matrixelem(vars,0,ncomp,risc,weight,iternumber) 
      end



      subroutine givevalerr(Nmax, ris, cval, pluse, minuse,
     &     pdf_provider)
      
      implicit none 
      integer Nmax
      double precision ris(0:Nmax)
      double precision cval, pluse, minuse
      character*10 pdf_provider
      
      if ((pdf_provider.eq."MSTW")
     &     .or.(pdf_provider.eq."MSTW90")
     &     .or.(pdf_provider.eq."MSTW_P")
     &     .or.(pdf_provider.eq."MSTW_M")
     &     .or.(pdf_provider.eq."MSTW90_P")
     &     .or.(pdf_provider.eq."MSTW90_M")
     &     ) then 
         call MSTW_error(Nmax, ris, cval, pluse, minuse)
      elseif (pdf_provider.eq."GJR") then
         call GJR_error(Nmax, ris, cval, pluse, minuse)
      elseif (pdf_provider.eq."ABKM") then 
         call ABKM_error(Nmax, ris, cval, pluse, minuse)
      elseif (pdf_provider.eq."ABM") then 
         call ABM_error(Nmax, ris, cval, pluse, minuse)
      elseif ((pdf_provider.eq."NNPDF")
     &        .or.(pdf_provider.eq."NNPDF_14")
     &        .or.(pdf_provider.eq."NNPDF_15")
     &        .or.(pdf_provider.eq."NNPDF_16")
     &        .or.(pdf_provider.eq."NNPDF_17")
     &        .or.(pdf_provider.eq."NNPDF_18")
     &        .or.(pdf_provider.eq."NNPDF_20")
     &        .or.(pdf_provider.eq."NNPDF_21")
     &        .or.(pdf_provider.eq."NNPDF_22")
     &        .or.(pdf_provider.eq."NNPDF_23")
     &        .or.(pdf_provider.eq."NNPDF_24")
     &        .or.(pdf_provider.eq."NNPDF23")
     &        .or.(pdf_provider.eq."NNPDF23_M")
     &        .or.(pdf_provider.eq."NNPDF23_P")
     &	    ) then 
         call NNPDF_error(Nmax, ris, cval, pluse, minuse)
      elseif ((pdf_provider.eq."CT10")
     &        .or.(pdf_provider.eq."CT10_M")
     &        .or.(pdf_provider.eq."CT10_P")
     &        ) then
         call MSTW_error(Nmax, ris, cval, pluse, minuse) ! it seems as if they used the same prescription
      else
         print*,"[givevalerr]: ERROR : no uncertainty", 
     &        " subroutine for ",pdf_provider," pdf provider"
      endif
      end

c---------------------------------------------------------------
c
c		MSTW error calculation
c
c		error according to eq. 51,52 of 
c		http://arxiv.org/abs/0901.0002v3
c
c
	
	subroutine MSTW_error(Nmax, ris, cval, pluse, minuse)
      implicit none 
      integer Nmax, jj, jplus, jminus
      double precision ris(0:Nmax)
      double precision cval, pluse, minuse, esymm 
      double precision tmp, tmp1, tmp2
	
      cval=ris(0)
      pluse=0d0
      minuse=0d0
	!print*,"**************************"
	print*,"Central value ",ris(0)
	!print*,"Central = ",ris(0)
      esymm = 0d0
      do jj=1,Nmax/2
         !print*,jj,ris(2*jj),ris(2*jj+1) 
         jplus = 2*jj
         jminus = 2*jj-1

         tmp1 = ris(jplus) - cval
         tmp2 = ris(jminus) - cval
	   !print*,jj," R+ ",tmp1," R- ",tmp2
         if (tmp1.gt.tmp2) then 
            tmp = tmp1 
         else
            tmp = tmp2
         endif
         if (tmp.lt.0d0) then 
            tmp = 0d0
         endif
         pluse = pluse + tmp**2         
		!print*,"(+) ->",tmp
         tmp1 = - tmp1
         tmp2 = - tmp2
         if (tmp1.gt.tmp2) then 
            tmp = tmp1 
         else
            tmp = tmp2
         endif
         if (tmp.lt.0d0) then 
            tmp = 0d0
         endif
		!print*,"(-) ->",tmp
         minuse = minuse + tmp**2

         esymm = esymm + (tmp1-tmp2)**2

      enddo

      esymm = dsqrt(esymm)/cval*100d0/2d0

      pluse=dsqrt(pluse)/cval*100d0
      minuse=dsqrt(minuse)/cval*100d0

C----  for symmetric  error uncomment here
C      pluse = esymm
C      minuse = esymm

      end
	
c---------------------------------------------------------------
c
c		GJR error calculation
c
c		dS = 1/2 sqrt( sum{ (S_i+ - S_i- )^2 } )
c
c		see eq. 2.10 of http://arxiv.org/abs/0902.3947v1 
c
c		Note: the error is by construction symmetric
c
	subroutine GJR_error(Nmax, ris, cval, pluse, minuse)
      implicit none 
      integer Nmax, jj
      double precision ris(0:Nmax)
      double precision cval, esymm,pluse,minuse 

	
      cval=ris(0)
      
	esymm=0d0
	print*,"Central value ",ris(0)
      esymm = 0d0
      do jj=1,Nmax/2
	!	print*,jj," ",ris(2*jj)," ",ris(2*jj+1) 
		esymm = esymm+(
     $		 ( ris(2*jj) - ris(2*jj-1) )**2
     $			)
	enddo

      esymm = dsqrt(esymm)/cval*100d0/2d0
	
	!: workaround of the fact that at LO there is the FF and the VF
	!: scheme in one set...
	if (Nmax.eq.1) then 
		esymm=0d0
		cval = ris(1)
	endif
	
	pluse=esymm
	minuse=esymm
	
	end

c---------------------------------------------------------------
c
c		ABKM error calculation
c
c		dS =  sqrt( sum{ (S_i+ - S_0 )^2 } )
c
c
c		Note: the error is by construction symmetric
c
	subroutine abkm_error(Nmax, ris, cval, pluse, minuse)
      implicit none 
      integer Nmax, jj
      double precision ris(0:Nmax)
      double precision cval, esymm,pluse,minuse 

	
      cval=ris(0)
      
	esymm=0d0
	print*,"Central value ",ris(0)
      esymm = 0d0
      do jj=1,Nmax
	!	print*,jj," ",ris(jj)," ",ris(jj)-ris(1) 
		esymm = esymm+(
     $		 ( ris(jj) - ris(0) )**2
     $			)
	enddo

      esymm = dsqrt(esymm)/cval*100d0
	
	pluse=esymm
	minuse=esymm
	
	end

c---------------------------------------------------------------
c
c		NNPDF error calculation
c
c		dS =  sqrt( 1/(ngrids-1)*sum{ (S_i+ - S_0 )^2 } )
c
c
c		Note: the error is by construction symmetric
c
      subroutine nnpdf_error(Nmax, ris, cval, pluse, minuse)
      implicit none 
      integer Nmax, jj
      double precision ris(0:Nmax)
      double precision cval, esymm,pluse,minuse 
      
      
      cval=ris(0)
      
      esymm=0d0
      print*,"Central value ",ris(0)
      esymm = 0d0
      do jj=1,Nmax
!	print*,jj," ",ris(jj)," ",ris(jj)-ris(1) 
         esymm = esymm+(
     $        ( ris(jj) - ris(0) )**2
     $        )
      enddo
      
      esymm = dsqrt(esymm/(Nmax-1))/cval*100d0
      
      pluse=esymm
      minuse=esymm
      
      end
      
c---------------------------------------------------------------
c
c		ABM error calculation
c
c		dS =  sqrt( sum{ (S_i+ - S_0 )^2 } )
c
c
c		Note: the error is by construction symmetric
c
	subroutine abm_error(Nmax, ris, cval, pluse, minuse)
      implicit none 
      integer Nmax, jj
      double precision ris(0:Nmax)
      double precision cval, esymm,pluse,minuse 

	
      cval=ris(0)
      
	esymm=0d0
	print*,"Central value ",ris(0)
      esymm = 0d0
      do jj=1,Nmax
	!	print*,jj," ",ris(jj)," ",ris(jj)-ris(1) 
		esymm = esymm+(
     $		 ( ris(jj) - ris(0) )**2
     $			)
	enddo

      esymm = dsqrt(esymm)/cval*100d0
	
	pluse=esymm
	minuse=esymm
	
	end


