
	subroutine my_interpolated_pdf(x,alpha_set_index, 
     &			member_set_index,
     &			upv,dnv,usea,dsea,str,
     &			chm,bot,glu)
      implicit none
      integer alpha_set_index,member_set_index
      double precision x,upv,dnv,usea,dsea,str,chm,bot,glu
	double precision up_total,down_total
	
	call C_values(x,alpha_set_index,member_set_index,2,up_total)
	call C_values(x,alpha_set_index,member_set_index,-2,usea)
	upv=up_total - usea
	call C_values(x,alpha_set_index,member_set_index,1,down_total)
	call C_values(x,alpha_set_index,member_set_index,-1,dsea)
	dnv=down_total - dsea
	call C_values(x,alpha_set_index,member_set_index,3,str)
	call C_values(x,alpha_set_index,member_set_index,4,chm)
	call C_values(x,alpha_set_index,member_set_index,5,bot)
	call C_values(x,alpha_set_index,member_set_index,0,glu)

	end subroutine
	
	
	
c---------------------------------------------------------------------------
c     retrieves the pdfs using the LHAPDf routines:
c------------------------------------------------------------------------------
      subroutine my_lha_pdfs(x,muf,alpha_set_index, 
     &			member_set_index,
     &			upv,dnv,usea,dsea,str,
     &			chm,bot,glu)
      implicit none    
	integer alpha_set_index,member_set_index
      double precision x,upv,dnv,usea,dsea,str,chm,bot,glu
      doubleprecision muf
      integer iset
      double precision f(-6:6)
      
      iset=alpha_set_index! dummy statement
	iset=member_set_index!dummy statement
      call evolvePDF(x,muf,f)
	upv = f(2) - f(-2)
	usea = f(-2)
	dnv = f(1) - f(-1)
	dsea = f(-1)
	str = f(3)
	chm = f(4)
	bot = f(5)
	glu = f(0)
      
	end subroutine


	
	
	subroutine C_values(x,alpha_set_index,member_set_index,
     $flavour_index,my_value)
	implicit none
	integer alpha_set_index,member_set_index,flavour_index,L
	double precision my_value,x
	include 'pdf_eigen_alpha.h'
	DOUBLEPRECISION HH,lambda,rr
	
	
	
	hh = Np*(Np-1)/(1D0-XMIN)
      lambda = (x-XMIN)*hh
      if(lambda.lt.0d0) then
         write(6,*) 'WARNING: x out of fitting range: x=',x,
     &		' xmin=',xmin
         lambda=0d0
      endif
      rr = 0.5d0*(1.0d0+dsqrt(1+4.d0*lambda))
      L =int(rr) 
      
	my_value = (
     &	C(alpha_set_index,member_set_index,3,L,flavour_index)
     &    + x * C(alpha_set_index,member_set_index,2,L,flavour_index) 
     &    + x**2 * C(alpha_set_index,member_set_index,1,L,flavour_index)
     &	 )
	
	end subroutine


c---------------------------------------------------------------------------
c     evolves a_s and yukawa for each PDF member to mur 
c------------------------------------------------------------------------------
	subroutine evolve_as_yukawa(mur,porder,Ngrids)
	implicit none
	double precision mur,SSC,yukawa_b,m0,m,cutoff,delta
	character*60 porder
	integer Ngrids,imember,i
	double precision mu_bot0,lambda0,active_flavours,yuk_factor
	!: alph_yukawa communicates with Higgs.F inside the integration loop
	include 'alpha_yukawa.h'
	!
	double precision double_mq(100),Yq(100),Gq(100)
	double complex Wq(100),Xq(100),Mq_square_complex(100)
	integer  number_of_quarks, qscheme(100)
	common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,Gq,
     &     qscheme,number_of_quarks
!
	double precision Gf
	common /comGf/ Gf
	!
	!: running of yukawa_b , i.e. of m_b
      !: mur0 initial scale for m_b
      !: mbot @ 10 GeV from arXiv:hep-ph/0705.2335 
      !: mur0 and 
	double precision mu_c_0,yukawa_charm
	! original_masses : necessary for evolution at different orders
	double precision original_masses(100)
	common /OriginalMasses/ original_masses
	
	mu_bot0= 10d0
	yuk_factor = dsqrt(dsqrt(2d0)*Gf)
	active_flavours=5
	cutoff=1e-3
      
	print*,"Running of coupling constants and masses."     

c	if some weirdo chooses the pole scheme for the bottom then we also
c	do not run the yukawa, i.e. in all cases we just take the yukawa
c	as the bottom mass times Y_b divided by v.
	

	do i=1,number_of_quarks
	   m = original_masses(i) ! pole case
	   if ((qscheme(i).eq.0).and.(original_masses(i).gt.10d0)) then
	      m0 = original_masses(i)
	      m = yukawa_b(mur,porder,m0,m0,active_flavours,alphaMz(0)) 
	 elseif((qscheme(i).eq.0).and.(original_masses(i).lt.10d0)) then
	      m0 = original_masses(i)
	  m = yukawa_b(mur,porder,mu_bot0,m0,active_flavours,alphaMz(0))
	   endif
	   ! store into common block
	   double_mq(i) = m
	   
	   if (abs(Gq(i)/m).gt.cutoff) then 
	 Mq_square_complex(i) = double_mq(i)*dcmplx(double_mq(i),-Gq(i))
	   else
	      delta =  1d-16
	      Mq_square_complex(i) = dcmplx(double_mq(i)**2,-delta)
	   endif
	enddo

c       alphas and yukawas:	
	do imember=0,Ngrids
	   alphas(imember) = SSC(mur,alphaMz(imember),porder)
	   if((qscheme(2).eq.0).and.(original_masses(2).lt.10d0)) then
	      lambda0 = original_masses(2)*yuk_factor
	      yukawa_bb(imember) = yukawa_b(mur,porder,mu_bot0,lambda0,
     &active_flavours,alphaMz(imember) )
	   endif
	enddo
	
c	do i=1,number_of_quarks
c	   print*, original_masses(i),double_mq(i),Mq_square_complex(i)
c     &,double_mq(i)**2,qscheme(i)
c	enddo

	end




               
   
